;;;; wh-engine system definition
;;;; Copyleft (C) 2021 ~keith

(defsystem "wh-engine"
  :version "0.1.0"
  :description "A game engine written in Common Lisp."
  :author "~keith"
  :license "GNU AGPLv3"
  :depends-on ("sdl2" "cl-opengl" "trivial-types" "objective-lisp" "3d-vectors" "3d-matrices")
  :components
  ((:module "wh-engine"
    :components ((:file "package")
                 (:file "global")
                 (:file "actor")
                 (:file "component")
                 (:file "actor-macros")
                 (:file "scene")
                 (:file "serialization")
                 (:file "systems")
                 (:module "render"
                  :components ((:file "render-system")
                               (:file "shader")
                               (:file "drawable")
                               (:file "render-target")
                               (:file "view")))
                 (:module "input"
                  :components ((:file "input-system")))
                 (:file "main"))
    )))
